--- HUD specific variables
hud = {
	live = { -- variables that keep track of "activated" objects such as open windows and clicked buttons
		openwindows = {
				HudBar = {}

			},

	},

	windows = {},
}

--Classes
HudWindow_Class = class(function(tableholder, Name, Position, Images, ImagePositions, Buttons, vars)
tableholder.Name = Name -- Identifier, internal use only
tableholder.Position = Position -- The position of hte window
tableholder.Images = Images	--All of the images used by the window
tableholder.ImagePositions = ImagePositions -- Where to place the images in relation to the window's position.
tableholder.Buttons = Buttons 	-- Keeps track of which buttons this window holds with values shown as a table: {Relative X, Relative Y, Action, {Images}}
tableholder.vars = vars 	-- A place to store any variables unique to that particular window
end)

-- Methods
function HudWindow_Class:draw( Xoffset, yoffset )
	for numdraw in pairs(self.Images) do
		love.graphics.draw(self.Images[numdraw],
		self.Position[1] + self.ImagePositions[numdraw][1] + Xoffset,
		self.Position[2] + self.ImagePositions[numdraw][2] + yoffset)
	end

	for b in pairs(self.Buttons) do
		for i in pairs(self.Buttons[b][4]) do
			if self.Buttons[b][4][1] then
				love.graphics.draw(self.Buttons[b][4][i],
				self.Position[1] + self.Buttons[b][1] + Xoffset,
				self.Position[2] + self.Buttons[b][2] + yoffset)
			end
		end
	end
	if self.vars.text then
		for t in pairs(self.vars.text) do
			love.graphics.drawf( 		self.vars.text[t][1],
									self.Position[1] + self.vars.text[t][2],
									self.Position[2] + self.vars.text[t][3],
									self.vars.text[t][4]
								)
		end
	end

	if self == hud.windows.Inventory then
		for x = 1, hud.windows.Inventory.vars.grid.x do
			for y = 1, hud.windows.Inventory.vars.grid.y do
				if player.inventory[hud.windows.Inventory.vars.SelectedSlot][x][y][1] then
					local currentwindowimage = hud.windows.Inventory
					love.graphics.draw(
						player.inventory[hud.windows.Inventory.vars.SelectedSlot][x][y][1].hudimage,
						currentwindowimage.Position[1] + currentwindowimage.vars.grid.xorigin + ( (x - 1) * currentwindowimage.vars.grid.size) + currentwindowimage.vars.grid.size * 0.5,
						currentwindowimage.Position[2] + currentwindowimage.vars.grid.yorigin + ( (y - 1) * currentwindowimage.vars.grid.size) + currentwindowimage.vars.grid.size * 0.5,
						0,
						0.6
					)
				end
			end
		end
	end
end

-- For the inventory only right now, gets the coordinates of each cell in a grid
function HudWindow_Class:GetGridCoords()
local celltable = {}

return celltable
end

-- Windows
hud.windows = {

	HudBar = HudWindow_Class(
	"Main Hud Bar",
	{400, 570},
	{images.hud.main.bar},
	{ {0, 0}, },
	{ 	{-100, 0, {"world_AdvanceDay"}, {images.hud.buttons.nextgen} },
		{-370, 0, {"hud_ToggleWindow", "Inventory"}, {images.hud.buttons.inventory} },
		{-320, 0, {"hud_ToggleWindow", "Examine"}, {images.hud.buttons.examine} },	},
	{}
	),

	Examine = HudWindow_Class(
	"Examine Window",
	{675, 400},
	{images.hud.windows.examine_window},
	{ {0, 0}, },
	{ {-110, 37, {"hud_ToggleWindow", "Examine"}, {images.hud.buttons.close} }, },
	{}
	),

	Inventory = HudWindow_Class(
	"Inventory Window",
	{650, 300},
	{images.hud.windows.inventory_window, images.hud.boxes.inventory_main, images.hud.boxes.inventory_grid},
	{ {0, 0}, {0, 70}, {-66, 70} },
	{
		{-60, -270, {"hud_InventorySlotSelect", "head"}, {images.hud.buttons.inventory_slot} }, 	-- head slot
		{-60, -215, {"hud_InventorySlotSelect", "torso"}, {images.hud.buttons.inventory_slot} }, 	-- torso slot
		{-110, -130, {"hud_InventorySlotSelect", "belt"}, {images.hud.buttons.inventory_slot} }, 		-- belt slot
		{-60, -165, {"hud_InventorySlotSelect", "legs"}, {images.hud.buttons.inventory_slot} }, 		-- pants slot
		{-60, -115, {"hud_InventorySlotSelect", "feet"}, {images.hud.buttons.inventory_slot} },		-- shoes slot
		{-110, -185, {"hud_InventorySlotSelect", "right_hand"}, {images.hud.buttons.inventory_slot} },	-- right hand slot
		{-10, -185, {"hud_InventorySlotSelect", "left_hand"}, {images.hud.buttons.inventory_slot} }, 	-- left hand slot
		{-115, -250, {"hud_InventorySlotSelect", "face_neck"}, {images.hud.buttons.inventory_slot} },	-- face/neck slot
		{-5, -250, {"hud_InventorySlotSelect", "back"}, {images.hud.buttons.inventory_slot} }, 	-- back slot

		{-135, 223, {"hud_ToggleWindow", "Inventory"}, {images.hud.buttons.close} },
	},
	{	SelectedSlot = nil,
		text = {
			{"The Slot", 30, -250, 100},
			{"Weight/max", 30, -235, 150},
			{"Volume/max", 30, -220, 150},
			{"Conditions, including warmth, damage, disease, infection, exhaustion, current use, etc. This is brief, details in diff window/tab", 35, -205, 100},
		},
		grid = {x = 5, y = 9, size = 30, xorigin = -141, yorigin = -70, },
	}
	),

}

function hud:load()

		hud:GetCurrentHudCoords()

end

function hud:update()
	--update inventory window images in each slot
	if hud.live.openwindows.Inventory then
		for id, slots in ipairs(player.inventory.slots) do
			if player.inventory[ slots ][1] then
				hud.windows.Inventory.Buttons[ id ][4][2] = player.inventory[ slots ][1].hudimage
			end
		end
	end


end

function hud:draw()
local huddraw
	for huddraw in pairs(hud.live.openwindows) do
		hud.windows[huddraw]:draw(0, 0)
	end
end

function hud:ActionIndex( key, ... )
	-- Next Day button on the hud bar
	if key == "world_AdvanceDay" then world:AdvanceDay() end

	-- for openning and closing windows, used with the close window button on each window as well as the window's button on the hud bar
	if key == "hud_ToggleWindow" and arg[1] then hud:ToggleWindow(arg[1] ) end

	if key == "hud_InventorySlotSelect" and arg[1] then hud:InventorySlotSelect(arg[1]) end
end

--gets the coordinates of all of the hud elements currently open to scan to see if the mouse is in them
-- This rebuilds the table hud.live.openwindows
function hud:GetCurrentHudCoords()
HudCoordsTable_S = love.timer.getTime()

	for eachwindow in pairs(hud.live.openwindows) do
		local currentwindowimage = hud.windows[eachwindow]


		--get coordinates for windows
		hud.live.openwindows[eachwindow].coords = {
		currentwindowimage.Position[1] - (currentwindowimage.Images[1]:getWidth() / 2),
		currentwindowimage.Position[2] - (currentwindowimage.Images[1]:getHeight() / 2),
		currentwindowimage.Position[1] + (currentwindowimage.Images[1]:getWidth() / 2),
		currentwindowimage.Position[2] + (currentwindowimage.Images[1]:getHeight() / 2),
		Buttons = {},
		}

		--get coordinates for buttons
		if currentwindowimage.Buttons[1] then
			for eachbutton in pairs(currentwindowimage.Buttons) do
				local currentbuttonimage = currentwindowimage.Buttons
					hud.live.openwindows[eachwindow].coords.Buttons[eachbutton] = {
					currentwindowimage.Position[1] + currentbuttonimage[eachbutton][1] - (currentbuttonimage[eachbutton][4][1]:getWidth() / 2),
					currentwindowimage.Position[2] + currentbuttonimage[eachbutton][2] - (currentbuttonimage[eachbutton][4][1]:getHeight() / 2),
					currentwindowimage.Position[1] + currentbuttonimage[eachbutton][1] + (currentbuttonimage[eachbutton][4][1]:getWidth() / 2),
					currentwindowimage.Position[2] + currentbuttonimage[eachbutton][2] + (currentbuttonimage[eachbutton][4][1]:getHeight() / 2),
					}
			end
		end

		-- get coordinates for grid cells, same thing as a button but no image and not preset. Stored in the button table
		if currentwindowimage.vars.grid then
			hud.live.openwindows[eachwindow].coords.Grid = {}
			for x = 1, currentwindowimage.vars.grid.x do
				hud.live.openwindows[eachwindow].coords.Grid[x] = {}
				for y = 1, currentwindowimage.vars.grid.y do
					hud.live.openwindows[eachwindow].coords.Grid[x][y] = {
						currentwindowimage.Position[1] + currentwindowimage.vars.grid.xorigin + ( (x - 1) * currentwindowimage.vars.grid.size),
						currentwindowimage.Position[2] + currentwindowimage.vars.grid.yorigin + ( (y - 1) * currentwindowimage.vars.grid.size),
						currentwindowimage.Position[1] + currentwindowimage.vars.grid.xorigin + ( x * currentwindowimage.vars.grid.size),
						currentwindowimage.Position[2] + currentwindowimage.vars.grid.yorigin + ( y * currentwindowimage.vars.grid.size),
					}
				end
			end
		end
	end
HudCoordsTable = love.timer.getTime() - HudCoordsTable_S
end

function hud:InventorySlotSelect(Slot) --Button function
	if player.inventory[Slot][1] then
		hud.windows.Inventory.vars.SelectedSlot = Slot
	end
	local SlotNames = {head = "Head", torso = "Torso", belt = "Waist", legs = "Legs", feet = "Feet", left_hand = "Left Hand", right_hand = "Right Hand", face_neck = "Face", back = "Back"}
	hud.windows.Inventory.vars.text[1][1] = SlotNames[Slot]
	local SlotWtMult = {legs = 0.75, feet = 0.1, left_hand = 0.35, right_hand = 0.35, face_neck = 0.1}
	local CurSlot = SlotWtMult[Slot] or 1
	hud.windows.Inventory.vars.text[2][1] = "Wt: "..tostring(player.inventory[Slot].weight / 1000).."kg / "..tostring(CurSlot * player.strength * player.weight / 1000).."kg"
	local SlotVolMult = {legs = 0.2, feet = 0.05, left_hand = 0.5, right_hand = 0.5, face_neck = 0.1, torso = 0.3, belt = 0.4, back = 1, head = 0.1}
	hud.windows.Inventory.vars.text[3][1] = "Vol: "..tostring(player.inventory[Slot].volume / 1000).."lt / "..tostring(SlotVolMult[Slot] * player.strength * player.volume / 1000).."lt"
end

function hud:ToggleWindow(window) -- Button function
-- toggles the window by checkign if it's in the openwindows table andthen either adding or removing it as necessary
	if hud.live.openwindows[window] then
		hud.live.openwindows[window] = nil
	else
		hud.live.openwindows[window] = {}
	end

-- updates the coordinates for the hud windows
	hud:GetCurrentHudCoords()
end
