function love.load()
	Load_S = love.timer.getTime()

---- **** LIBRARY FILES
love.filesystem.load("class.lua")()
love.filesystem.load("AnAL.lua")()

---- **** LOAD IMAGES
love.filesystem.load("loadimages.lua")()

---- **** LOAD AUDIO
--love.filesystem.load("loadaudio.lua")()
--love.filesystem.load("audio.lua")()
--audio:load()

---- **** MOUSE (load after images)
love.filesystem.load("mouse.lua")()
mouse:load()


---- **** WORLD
love.filesystem.load("world.lua")()
world:load()

---- **** CLIMATE
love.filesystem.load("climate.lua")()


---- **** MAP LOAD (load after loadimages.lua)
love.filesystem.load("map.lua")()
map:load()

---- **** HUD (load after world.lua)
love.filesystem.load("hud.lua")()
hud:load()

---- **** PLANTS
love.filesystem.load("plants.lua")()
love.filesystem.load("plants_data.lua")()

---- **** PLAYER + MOVEMENT
love.filesystem.load("player.lua")()
player:load()

---- **** GAME OBJECTS
love.filesystem.load("objects_data.lua")()
love.filesystem.load("objects.lua")()
objects:load()

---- **** GAME AI
love.filesystem.load("AI.lua")()

---- **** GAME OVERLAYS/MASKS
love.filesystem.load("masks.lua")()

---- **** TEMPORARY (For map settings at load)
-- map file
	love.filesystem.load("0000_0000.lua")()

-- TESTAN
-- build table for drawing, a table with layers
map.layers = map:build_layers()

--DAT WRITAN
love.filesystem.write("DUMP.txt", TESTPLSDELETE() )

--=======END FILE LOADING=====
love.mouse.setVisible(false)
math.randomseed( os.time() )


--font table
font = {
	default = love.graphics.newFont("arial.ttf", 12),
	label = love.graphics.newFont("arial.ttf", 10),
	}

--colour table
colour = {
	default = {255,255,255},
	black = {0,0,0},
	}
love.graphics.setColor(unpack(colour.default))
love.graphics.setFont(font.default)

--table for miscellaneous variables
misc = {
	ButtonAction = false -- probably temporary, when a button is pressed this variable will be used to call teh function for the action, which shoiuld return true if successful or false otherwise
}


local Slot = player.inventory.slots[math.random(1,9)]
hud:InventorySlotSelect("head")
hud.windows.Inventory.vars.SelectedInventoryItem = player.inventory[2][4][1]
map.tile_map[50][50].environment.temperature = 300

	Load_Timer = love.timer.getTime() - Load_S
end

function TESTPLSDELETE()
local string = ""
if map.tile_map[50][50].objects and type(map.tile_map[50][50].objects) == "table" then
	for i,v in pairs(map.tile_map[50][50].objects[1]) do
		if type(v) == "table" then
		string = string..tostring(i).." = ".."{ "..TABLEORNO(v).." }, | "
		else
		string = string..tostring(i).." = "..tostring(v)..", | "
		end
	end
end
return string
end

function TABLEORNO(VALUE)
local words = ""
	for i,v in pairs(VALUE) do
		if type(v) == "table" then
		words = words..tostring(i).." = ".."{ "..TABLEORNO(v).." }, | "
		else
		words = words..tostring(i).." = "..tostring(v)..", | "
		end
	end
return words
end

function love.update()
--UPDATE VARIABLES
	dt = love.timer.getDelta()

--====UPDATE PLAYER
	player:update(dt)

--====UPDATE HUD
	hud:update(dt)

--====UPDATE WORLD
	world:update(dt)

--====UPDATE MAP
	map:update(dt)

--====UPDATE MOUSE
	mouse:update(dt)

--====UPDATE Audio
	--audio:update(dt)

	if not love.keyboard.isDown( "a" ) then
		--world:AdvanceDay()
	end
end

function love.draw()
	-- player:draw() is in map:draw() so I can have the player overlap some things.
	--I'm going to have everything drawn in the game world be deckared in map:draw()
	--until further notice

	map:draw()

	hud:draw()

	-- non game related text for testing
	love.graphics.setColor(0,0,0,255)
	love.graphics.print("map_x = "..map_x.."  map_y = "..map_y, 20, 590)
	love.graphics.print("Mouse.InCell: "..tostring(mouse.InCell), 650, 560)
	love.graphics.print(tostring(map:getdaylength()), 200, 590)
	love.graphics.print("Date: "..tostring(world.time.month).."/"..tostring(world.time.day).."/"..tostring(world.time.year), 400, 590)
	love.graphics.print("FPS: "..love.timer.getFPS(), 540, 590)
	love.graphics.print("Something: "..tostring(mouse.InTile.x)..", "..tostring(mouse.InTile.y), 650, 570)
	love.graphics.print("Load: "..tostring(Load_Timer or "OOGABOOGA"), 650, 580)
	love.graphics.print("Time: "..tostring(dt), 650, 590)
	love.graphics.print("Snow: "..tostring(map.tile_map[49][49].earth.cover.amount), 550, 580)
	if mouse.InHud then love.graphics.print("MOUSE IN HUD!!!!!", 540, 580) end

	mouse:draw() -- Draw last, IE on top of everything.

end

function love.keypressed(key)
--[[
Enter = Next Generation
Insert = Fullscreen
I = Inventory
Q = Quit
R = Restart
L = Examine (Look?)
F1 = Console
--]]
	if key == "return" then
		world:AdvanceDay()
	-- map.tile_map[50][50].environment.temperature = 200
	end

	if key == "i" then
		hud:ToggleWindow("Inventory")
	end

	if key == "e" then
		hud:ToggleWindow("Examine")
	end

	if key == "q" then
		love.event.push("q")
	end

	if key == "r" then
		love.load()
	end

	if key == "t" then
		if map.masks.thermal == true then map.masks.thermal = false
		else map.masks.thermal = true end
	end

	if key == "insert" then
		love.graphics.toggleFullscreen()
	end
end

function love.keyreleased(key)
	if key == "down" then
		player.state = "idle"
	end

	if key == "up" then
		player.state = "idle"
	end

	if key == "right" then
		player.state = "idle"
	end

	if key == "left" then
		player.state = "idle"
	end
end

-- Mouse clickan
function love.mousereleased( mousex, mousey, buttonpressed)
	if hud.live.openmenus.Menu then hud.live.openmenus.Menu = nil end

	if buttonpressed == "l" then
		-- activate buttons
		if mouse.OnButton then
			ActionTimer_S = love.timer.getTime()
			hud:ActionIndex( unpack( mouse.OnButton[3] ) )
			ActionTimer = love.timer.getTime() - ActionTimer_S
		end

		-- clicking and dragging stuff around in the inventory
		--if mouse.InCell then
			if mouse.DragObject.Object then
				--[[mouse.DragObject.Object = player.inventory[hud.windows.Inventory.vars.SelectedSlot][mouse.cell.x][mouse.cell.y][1]
				player.inventory[hud.windows.Inventory.vars.SelectedSlot][mouse.cell.x][mouse.cell.y] = {}
			else--]]
				mouse:DropObject()
			end
		--end
	end

	if buttonpressed == "r" then
		if mouse.InCell and
		player.inventory[mouse.cell.x][mouse.cell.y][1] then
			hud.windows.Inventory.vars.SelectedInventoryItem = player.inventory[mouse.cell.x][mouse.cell.y][1]
			hud:ToggleWindow("Menu")
		end

	end


end
