-- manage all the game overlays or masks

--initialize the table
masks = {}

function masks:precipitation()
	if map.environment.precipitation then
		for x = 0, 12 do
			for y = 0, 8 do
				images.world.weather[map.environment.precipitation_type][map.environment.precipitation_strength]:draw(x * 64, y * 64, 0, 1, 1, 1, 1)
			end
		end
	end
end

function masks:thermal(step, x, y)
	if not map.masks.thermal then return end
	if map.masks.thermal and step == "tint" then
		local blue
		local red
		local green
		if map.tile_map[x+map_x][y+map_y].environment.temperature < 1 then
			blue = 255
			green = 0
			red = 0
		elseif map.tile_map[x+map_x][y+map_y].environment.temperature > 100 then
			blue = 0
			green = 0
			red = 255
		elseif map.tile_map[x+map_x][y+map_y].environment.temperature > 50 then
				blue = 0
				green = ( 50 - ( map.tile_map[x+map_x][y+map_y].environment.temperature - 50 ) ) * 5.1
				red =  ( map.tile_map[x+map_x][y+map_y].environment.temperature - 50) * 5.1
		else
				blue = ( 50 - map.tile_map[x+map_x][y+map_y].environment.temperature ) * 5.1
				green = map.tile_map[x+map_x][y+map_y].environment.temperature * 5.1
				red =  0
		end
		love.graphics.setColor(red,green,blue,255)
	end

	if map.masks.thermal and step == "type" then
		love.graphics.setColor(255,255,255,100)
		love.graphics.print( tostring(map.tile_map[x+map_x][y+map_y].environment.temperature),
		(x-y) * (map.tile_w/2) + map.tile_w/3 + map.offset_x,
		(x+y)/2*map.tile_h + map.tile_map[y+map_y][x+map_x].earth.altitude + map.tile_h/2 + map.offset_y )
	end
end
