mouse = {
	x, y, -- Mouse Coordinates
	InHud, -- Switch with value true or false for checkign if the mouse is in the hud or not
	OnButton, --boolean
	InCell,		--boolean
	cell = {x = 0, y = 0}, -- holds the values of which cell teh mouse is in, if any.

	ToolTip = {	}, -- [1] = String or Image, [2] = X relative to mouse.x, [3] = Y relative to mouse.y
	DragObject = { Object = nil, OldLocation = nil }, -- holds an object

}

function mouse:load()

end

function mouse:update()
	mouse.x, mouse.y = love.mouse.getPosition()

	mouse.InHud = mouse:checkhud() -- see if the cursor is in the hud
	mouse.OnButton = mouse:checkbutton()
	mouse.InCell = mouse:checkgridcell()
	if not mouse.InHud then
		mouse.InTile = mouse:checktile()
	end

	-- clicking and dragging stuff around in the inventory
	if love.mouse.isDown("l" or "r") then
		if mouse.InCell and player.inventory[mouse.cell.x][mouse.cell.y][1] and not mouse.DragObject.Object then
			mouse.DragObject.Object = player.inventory[mouse.cell.x][mouse.cell.y][1]
			mouse.DragObject.OldLocation = { x = mouse.cell.x, y = mouse.cell.y }
			player.inventory[mouse.cell.x][mouse.cell.y] = {}
		end
	end
end

function mouse:draw()

	-- set the colour to default
	love.graphics.setColor(255,255,255,255)

	-- Draw Tooltips (or item descriptions in the inventory) (like in diablo)
	if not hud.live.openwindows.Menu then
		for index, lines in ipairs(mouse.ToolTip) do
			if type(lines[1]) == "string" then
				love.graphics.setColor(0,0,0,255)
				love.graphics.print(
					lines[1],
					mouse.x + lines[2],
					mouse.y + lines[3]
				)
			else
				love.graphics.setColor(255,255,255,255)
				love.graphics.draw(
					lines[1],
					mouse.x + lines[2],
					mouse.y + lines[3]
				)
			end
		end
	end

		-- The object the mouse is holding, if any
	if mouse.DragObject.Object then
		love.graphics.setColor(255,255,255,255)
		love.graphics.draw(
		mouse.DragObject.Object.hudimage,
		mouse.x ,
		mouse.y ,
		0,
		0.6
		)
	end

	-- Draw Cursor
	love.graphics.setColor(255,255,255,255)
	love.graphics.draw(mouse:GetCursorImage(), mouse.x, mouse.y)

	-- Draw Outline of the tile the player is in
	love.graphics.setColor(255,255,255,255)
	love.graphics.draw(images.cursors.tileselect, player.tile_x, player.tile_y)
end

-- Mouse Methods

-- check to see which cursor to draw
function mouse:GetCursorImage()
	if action then

	else
		return images.cursors.default
	end
end


-- Checks to see if the mouse is in the hud
function mouse:checkhud()
	for checkmouse in pairs(hud.live.openwindows) do
		if
		mouse.x >= hud.live.openwindows[checkmouse].coords[1] and
		mouse.y >= hud.live.openwindows[checkmouse].coords[2] and
		mouse.x <= hud.live.openwindows[checkmouse].coords[3] and
		mouse.y <= hud.live.openwindows[checkmouse].coords[4] then
			return true
		end
	end
	return false
end

-- Checks if the mouse is hovering over a button
function mouse:checkbutton()
	for eachwindow in pairs(hud.live.openwindows) do
		if hud.live.openwindows[eachwindow].coords.Buttons[1] then
			for eachbutton in pairs(hud.live.openwindows[eachwindow].coords.Buttons) do
				if
				mouse.x >= hud.live.openwindows[eachwindow].coords.Buttons[eachbutton][1] and
				mouse.y >= hud.live.openwindows[eachwindow].coords.Buttons[eachbutton][2] and
				mouse.x <= hud.live.openwindows[eachwindow].coords.Buttons[eachbutton][3] and
				mouse.y <= hud.live.openwindows[eachwindow].coords.Buttons[eachbutton][4] then
					return hud.windows[eachwindow].Buttons[eachbutton]
				end
			end
		end
	end
	return false

end

-- Essentially the same as checkbutton(), this sets coordinates for grid cells
function mouse:checkgridcell()
	for eachwindow in pairs(hud.live.openwindows) do
		if hud.live.openwindows[eachwindow].coords.Grid then
			for x = 1, hud.windows[eachwindow].vars.grid.x do
				for y = 1, hud.windows[eachwindow].vars.grid.y do
					if
					mouse.x >= hud.live.openwindows[eachwindow].coords.Grid[x][y][1] and
					mouse.y >= hud.live.openwindows[eachwindow].coords.Grid[x][y][2] and
					mouse.x <= hud.live.openwindows[eachwindow].coords.Grid[x][y][3] and
					mouse.y <= hud.live.openwindows[eachwindow].coords.Grid[x][y][4] then
						mouse.cell.x = x
						mouse.cell.y = y

						if eachwindow == "Inventory" then
							if player.inventory[x][y][1] then
								mouse.ToolTip[1] = { images.hud.windows.inventory_window_info, 15, 5 	}
								mouse.ToolTip[2] = { player.inventory[x][y][1].name, 35, 18 	}
								mouse.ToolTip[3] = { "Wt: "..tostring(player.inventory[x][y][1].weight).."g  Vol: "..tostring(player.inventory[x][y][1].volume).."lt", 35 ,30}
							else
								for line in pairs(mouse.ToolTip) do
									mouse.ToolTip[line] = nil
								end
							end
						end
						return hud.live.openwindows[eachwindow].coords.Grid[x][y]
					end
				end
			end
		end
	end
	mouse.cell.x = 0
	mouse.cell.y = 0
	return false
end

--FOR CHECKING WHICH TILE THE MOUSE IS OVER
function mouse.checktile()
	local tile_results = {x, y}
		tile_results.x = math.floor( (mouse.x - map.offset_x) / map.tile_w ) + map_x
		tile_results.y = math.floor( (mouse.y - map.offset_y) / map.tile_h ) + map_y
--(x-y) * (map.tile_w/2) + map.offset_x + scroll_x,
       --     (x+y)/2*map.tile_h + map.tile_map[y+map_y][x+map_x].earth.altitude + map.offset_y + scroll_y
	return tile_results
end

-- for dropping objects being dragged by the mouse_left
function mouse:DropObject()
	if mouse.InCell then
		if not player.inventory[mouse.cell.x][mouse.cell.y][1] then
			-- assign the cell the mouse is over to hold the item the mouse has
			player.inventory[mouse.cell.x][mouse.cell.y][1] = mouse.DragObject.Object
			-- assign the currently selected item to the item just clicked on
			hud.windows.Inventory.vars.SelectedInventoryItem = mouse.DragObject.Object
			-- remove the item from the mouse carried slot
			mouse.DragObject.Object = nil
		else
			player.inventory[mouse.cell.x][mouse.cell.y][1], mouse.DragObject.Object = mouse.DragObject.Object, player.inventory[mouse.cell.x][mouse.cell.y][1]
		end
	end

	--[[if mouse.OnButton[3][1] == "hud_InventorySlotSelect" then
		for x in pairs(player.inventory[mouse.OnButton[3][2] ][hud.windows.Inventory.vars.grid.x]) do
			for y in pairs(player.inventory[mouse.OnButton[3][2] ][x][hud.windows.Inventory.vars.grid.y]) do
				if not player.inventory[mouse.OnButton[3][2] ][x][y][1] then
					player.inventory[mouse.OnButton[3][2] ][x][y][1] = mouse.DragObject.Object
					mouse.DragObject.Object = nil
				end
			end
		end
	end--]]

	if mouse.InHud == false then
		table.insert(map.tile_map[map_y + 13][map_x + 17].objects, mouse.DragObject.Object)
		mouse.DragObject.Object = nil
	end

end
