objects = {
-- other variables
	live = {},
-- object types
}

--[[variable reference--
	IMAGE_TYPE:	10 = normal single image
				20 = quad (second digit is number of extra images to draw)
				4 = animation
--]]

ObjectBase = class(function(tableholder, name, worldimage, hudimage, actions, stats)
	tableholder.name = name
	tableholder.worldimage = worldimage
	tableholder.hudimage = hudimage
	tableholder.actions = actions
	tableholder.stats = stats
end)

-- special object states that cause them to affect things
objects.states = {
	-- for plant seeds and living plants
	planted = {

	}
}

-- main data table, objects and groups are in alphabetical order
-- Actual objects statistics
objects.base = {
		earth = ObjectBase(
			{"Dirt", "Dirt" },
			images.world.tiles.earth,
			images.hud.items.natural.seeds,
			{"kill", "something else"},
				{
					integrity = 10,
					weight = 50,
					volume = 1000000,
					hardness = 0
				}
		),

		flower = ObjectBase(
			{"Flower", "Flowers" },
			images.world.tiles.flowers,
			images.hud.items.natural.plants,
			{"kill", "something else"},
				{
					base_name = "flower",
					IMAGE_TYPE = 20,
					integrity = 10,
					weight = 50,
					volume = 0.5,
					hardness = 0,
					age = 0, -- age, in days
					age_step = 1, -- age "step", for assigning what image to draw
					age_steps = {0, 10, 20, 30, 40}, -- every newday function the age is compared to each of these and a new age step is assigned if necessary
					traits = {
					},
					flags = {"flower", "plant", "alive"},
				}
		),

		grass = ObjectBase(
			{"Grass", "Grasses" },
			images.world.tiles.grass,
			images.hud.items.natural.seeds,
			{"kill", "something else"},
				{
					base_name = "grass",
					IMAGE_TYPE = 20,
					integrity = 10,
					weight = 50,
					volume = 0.5,
					hardness = 0,
					age = 0, -- age, in days
					age_step = 1, -- age "step", for assigning what image to draw
					age_steps = {0, 10, 20, 30, 40}, -- every newday function the age is compared to each of these and a new age step is assigned if necessary
					traits = {
					},
					flags = {"grass", "plant", "alive"},
				}
		),

		seeds = ObjectBase(
			{"Seed", "Seeds" }, --soft seeds = 1, nomral = 2-4, hard = 5-10
			images.world.items.natural.seeds,
			images.hud.items.natural.seeds,
			{"text", "more text", "even more text", "some text here"},
				{
					base_name = "seeds",
					integrity = 10,
					weight = 50,
					volume = 0.5,
					hardness = 0,
					traits = {
						alive = true,
						active = true, -- should be false and then activated by sun and rain and shit
					},
					flags = {"seed", "alive"},
				}
		),

		water = ObjectBase(
			{"Water", "Water" },
			images.world.tiles,
			"test",
			{"text", "more text", "even more text", "some text here"},
				{
					base_name = "water",
					integrity = 10,
					weight = 50,
					volume = 0.5,
					hardness = 0,

					traits = {
						"SUBSTANCE",
					},

				}
		),

}

-- modifiers for plant types
objects.variety = {
	--grasses
	meadow_foxtail = {
		name = "Meadow Foxtail",
		image = "meadow_foxtail",
		integrity = 5,
		weight = 0.5,
		volume = 0.008,
		hardness = 0,
		actions = {"poo", "poo"},
	},
	--flowers
	wild_lupin = {
		name = "Wild Lupin",
		image = "wild_lupin",
		integrity = 5,
		weight = 5,
		volume = 0.01,
		hardness = 1,
	},
	Field_Poppy = {
		name = "Field Poppy",
		image = "field_poppy",
		integrity = 5,
		weight = 0.5,
		volume = 0.0025,
		hardness = 0,
		actions = {"test", "test"}
	},
	--trees
	Red_Maple = {
		name = "Red Maple",
		image = "red_maple",
		integrity = 5,
		weight = 2,
		volume = 0.025,
		hardness = 0
	},
	--water
	Snow = {
		name = "Snow",
		image = "snow",
		integrity = 5,
		weight = 2,
		volume = 0.025,
		hardness = 0
	},

}
