--[[
Right so, here's how it works. This is a tree of plant types grouped thusly:
	Plants
		Grasses
			Meadow Foxtail
		Flowers
		Trees
Only one of each secondary type can be on a given tile at any time.
Adding new classes require a function with at least two values,
the first being the table the rest are stored in, hence the name "tableholder".

The function "class" is defined in class.lib and I don't know how it
works exactly, but I get the general idea. I hope this doesn't fuck me over
in the end. Thanks to whoever made it on the Lua website, it has saved me a ton
of time figuring out how to do proper OOP in this damned language.

Adding appropriate value defaults can be done with methods, I think.
--]]

--***Classes (Should be a base Plant class as well as each basic subclass (grass, flowers, trees, etc.)
PlantClass = class(function(tableholder, name, image, SeedsNum, SuccessFactor, SpreadRadius, AgeBarrier, LevelCap, SunRequirement)
	tableholder.name = name
	tableholder.image = image
	tableholder.SeedsNum = SeedsNum or 1
	tableholder.SuccessFactor = SuccessFactor or 10
	tableholder.SpreadRadius = SpreadRadius or 2
	tableholder.AgeBarrier = AgeBarrier or 25
	tableholder.LevelCap = LevelCap or 3
	tableholder.SunRequirement = SunRequirement
end)

--Plant Methods

--Age plants and assign new sprites if appropriate
function PlantClass:age(Age, Level, Shadow)
	local NextLevelinTable = Level + 2 -- for getting values in tables, since base level is 0
	if Level < self.LevelCap and Age > self.AgeBarrier then
		local Chance_to_level = math.random(1, self.AgeBarrier)
		if Chance_to_level == 1 and 5 - Shadow >= self.SunRequirement[NextLevelinTable] then
			return true
		else
			return false
		end
	else
		return false
	end
end

--Returns the image file for a given plant.
function PlantClass:GetImage()
	return self.image
end

--Grows plants in the NEWDAY funciton
function PlantClass:grow( x, y, PlantType)
	for SeedsNum = 1, self.SeedsNum do
		check_growth_success = math.random(1, self.SuccessFactor)
		if check_growth_success == 1 then
			spread_x = math.random(-self.SpreadRadius, self.SpreadRadius)
			spread_y = math.random(-self.SpreadRadius, self.SpreadRadius)
			if map.tile_map[y+spread_y]
			and map.tile_map[y+spread_y][x+spread_x]
			and 5 - map.tile_map[y+spread_y][x+spread_x].environment.shadow >= self.SunRequirement[1]
			and	not map.tile_map[y+spread_y][x+spread_x].plants[PlantType].species then
				-- plants dispersing actual seeds
				objects:Instance(map.tile_map[y+spread_y][x+spread_x].objects, objects.base.seeds, objects.variety.Wild_Lupin)
			end
		end
	end
end

-- Set shadow level for the next day, taking the weather and trees into account
function PlantClass:SetNewShadows(x, y, Level)
	local LevelinTable = Level + 1
	for shadowx = -self.ShadowRadius[LevelinTable], self.ShadowRadius[LevelinTable] do
		for shadowy = -self.ShadowRadius[LevelinTable], self.ShadowRadius[LevelinTable] do
			if map.tile_map[y+shadowy][x+shadowx].environment.shadow < self.ShadowDegree[LevelinTable] then
				map.tile_map[y+shadowy][x+shadowx].environment.shadow = self.ShadowDegree[LevelinTable]
			end
		end
	end
end

GrassClass = class(PlantClass, function(tableholder, name, image, SeedsNum, SuccessFactor, SpreadRadius, AgeBarrier, LevelCap, SunRequirement)
	PlantClass.init(tableholder, name, image, SeedsNum, SuccessFactor, SpreadRadius, AgeBarrier, LevelCap, SunRequirement)
end)

FlowerClass = class(PlantClass, function(tableholder, name, image, SeedsNum, SuccessFactor, SpreadRadius, AgeBarrier, LevelCap, SunRequirement)
	PlantClass.init(tableholder, name, image, SeedsNum, SuccessFactor, SpreadRadius, AgeBarrier, LevelCap, SunRequirement)
end)

TreeClass = class(PlantClass, function(tableholder, name, image, SeedsNum, SuccessFactor, SpreadRadius, AgeBarrier, LevelCap, SunRequirement, ShadowRadius, ShadowDegree)
	PlantClass.init(tableholder, name, image, SeedsNum, SuccessFactor, SpreadRadius, AgeBarrier, LevelCap, SunRequirement)
	TreeClass.ShadowRadius = ShadowRadius
	TreeClass.ShadowDegree = ShadowDegree
end)
