--[[
LOAD AFTER PLANTS.LUA
Man plants datafile, holds all relevant data regarding plant species
standard image table naming format is the species name with underscores all in lowercase
	 order of values:
		For all plants:
			1) 	Ingame Name
			2) 	Image. For flowers and grass it's { image path, tile width, tile height }.
					For trees it's {image path, {sapling width, sapling height},
						{age 1 x, age 1 y, age 1 width, age 1 height, age 1 stump x,
						age 1 stump y, age 1 stump size (square), age 1 stump y offset,
						age 1 y offset}, ...for each age group of the tree (should be 4
						+ 1 for the sapling)}
			3)	Number of seeds it releases each day (during seeding period if appropriate)
			4)	Odds the seed will survive and grow into a plan, factored as 1 in N
			5)	The size of the area a plant can spread to, given in a radius
			6)	Age when a plant has a chance to grow bigger. This is represented in "levels"
					where a plant gains a level and gains different attributes (later on).
					For now it just draws a different sprite and then resets the age to 0.
					The odds are given in 1 in N and each day the odds increase (1 in N - (Age - N))
					So assuming the odds are 1 in 25, when it's 25 days old it has a 1 in
					25 chance of aging. At 35 days old the chances are 1 in 15 and at 49 they are
					1 in 1 (guarenteed)
			7) 	Highest level the plant can get to, usually limited by how many sprites I have (derp)
			8)	Amount of sun it needs to grow to the next "level". Mostly affects trees.
		For trees only:
			9) 	Shadow cast by the tree at each age, given in radius
			10) Shadow of the tree given in amount of shadow.
--]]

plants = {

--*** GRASSES

	Meadow_Foxtail = GrassClass(
		"Meadow Foxtail",
		{images.world.tiles.grass.meadow_foxtail, 26, 26},
		4,
		10,
		2,
		5,
		4,
		{1, 1, 1, 2, 2}
		),

--*** FLOWERS

	Field_Poppy = FlowerClass(
		"Field Poppy",
		{images.world.tiles.flowers.field_poppy, 25, 50},
		1,
		30,
		1,
		25,
		4,
		{1, 1, 2, 3, 4}
		),

	Wild_Lupin = FlowerClass(
		"Wild Lupin",
		{images.world.tiles.flowers.wild_lupin, 25, 50},
		1,
		50,
		2,
		25,
		4,
		{2, 3, 4, 5, 5}
		),

--*** TREES

	Red_Maple = TreeClass(
		"Red Maple",
		{	images.world.tiles.trees.red_maple,
			{ 25, 50 },
			{ 0, 0, 25, 50, 0, 75, 25, 25, 0, 10 },
			{ 25, 0, 75, 75, 25, 75, 25, 25, -8, 0 },
			{ 100, 0, 125, 125, 50, 75, 25, 25, -12, -6 },
			{ 225, 0, 125, 150, 75, 75, 25, 25, -20, -20 },
		},
		1,
		50,
		2,
		25,
		4,
		{0, 1, 1, 3, 3},
		-- From here, special tree attributes only
		{0, 0, 1, 2, 2},
		{0, 1, 1, 2, 2}
		),
}
