player = {
	-- Moving

	-- Sight in forest or darkness
	viewradius = 3,


	state = "idle",
	facing = "down",

	speed = {
		walk = 500, --for testing, real speed should be around 3. one square = 1 sq/m so 5 km/h == 1.38m/s
		run = 7,	-- 5 or 7, to be tested
	},

	-- Where to draw the player
	x = 400,
	y = 250,
	layer = 2,

	--basic player stats
	strength = 1, --set the standard for strength to that o f the average human. This is a real number and a multiplier.
	volume = 135000,
	weight = 70000,

	inventory = {
		slots = {},
		weight = 0,
		volume = 0,
		weightmax = 140000,
		volumemax = 270000,
		head = { weight = 0, volume = 0, topitem = false },
		torso = { weight = 0, volume = 0, topitem = false },
		belt = { weight = 0, volume = 0, topitem = false },
		legs = { weight = 0, volume = 0, topitem = false },
		feet = { weight = 0, volume = 0, topitem = false },
		left_hand = { weight = 0, volume = 0, topitem = false },
		right_hand = { weight = 0, volume = 0, topitem = false },
		face_neck = { weight = 0, volume = 0, topitem = false },
		back = { weight = 0, volume = 0, topitem = false },
	},
}

--Inventory shit


function player:load()
		for x = 1, hud.windows.Inventory.vars.grid.x do
			player.inventory[x] = {}
			for y = 1, hud.windows.Inventory.vars.grid.y do
				player.inventory[x][y] = {}
			end
		end

end

function player:update(dt)


	local player_oldstate = player.state

	-- testing run with shift (To be animated)
	if love.keyboard.isDown("lshift") then
		--self.state = "run"
	else
	--	self.state = "walk"
	end

	--change animation based on action
	if love.keyboard.isDown("up") then
		if map_y > 0 then
			self.facing = "up"
			self.state = "walk"
			scroll_y = scroll_y + (self.speed[self.state] * dt)
		end
	end
	if love.keyboard.isDown("down") then
		if map_y < map.size - map.display_h then
			self.facing = "down"
			self.state = "walk"
			scroll_y = scroll_y - (self.speed[self.state] * dt)
		end
	end
	if love.keyboard.isDown("left") then
		if map_x > 0 then
		self.facing = "left"
		self.state = "walk"
		scroll_x = scroll_x + (self.speed[self.state] * dt)
		end
	end
	if love.keyboard.isDown("right") then
		if map_x < map.size - map.display_w then
			self.facing = "right"
			self.state = "walk"
			scroll_x = scroll_x - (self.speed[self.state] * dt)
		end
	end

	if not love.keyboard.isDown("up") and
	not love.keyboard.isDown("down") and
	not love.keyboard.isDown("left") and
	not love.keyboard.isDown("right") then
		player.state = "idle"
	end


	--update animations
	images.world.player[self.state][self.facing]:update(dt)

	--update location
	self.tile_x = math.ceil(player.x/map.tile_w) * (map.tile_w + 1) + map.offset_x + scroll_x + 9
	self.tile_y = math.ceil(player.y/map.tile_h) * (map.tile_h + 1) + map.offset_y + scroll_y + 13

	--update player sounds for movement
	if player_oldstate ~= player.state then
		--audio:player(player.state)
	end

end

function player:draw(Height)
	images.world.player[self.state or "idle"][self.facing or "down"]:draw(player.x or 400, (player.y or 300) + Height, 0, 1, 1, 1, 1)

	--[[love.graphics.draw(images.world.player[self.state or "idle"][self.facing or "down"],
	player.x or 400,
	player.y or 300,
	0,
	1,
	1)--]]
end
